/* aanmeld_sel.c, outputs a form with fields to be filled out, in
 * order to search for some event.

 * Copyright (C) 2001,2002 M.C. Bezemer
 *
 * Licensed under the terms of the GNU General Public License.
 * ABSOLUTELY NO WARRANTY.
 * See the file `COPYING' in this directory.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include <cgic.h>

#include "untag.h"
#include "urlencode.h"
#include "urldecode.h"
#include "findvalue.h"
#include "tasquery.h"
#include "session.h"
#include "basicfunc.h"


struct doublestringmaplet {
	char *string1;
	char *string2;
	struct doublestringmaplet *next;
};


int cgiMain(void)
{
	char session_id[35];
	char *studienummer=NULL;
	char *wachtwoord=NULL;
	char *tas_stud_id=NULL;
	cgiFormResultType status;
	char *tasresponse=NULL;
	size_t tasresponse_len=0;
	char *temppointer=NULL;
	int dsm_counter=0;
	struct doublestringmaplet *dsm_list=NULL;
	struct doublestringmaplet *dsm_pointer=NULL;
	struct doublestringmaplet *dsm_pointer2=NULL;

	status=cgiFormString("session_id",session_id,35);
	if (status!=cgiFormSuccess) {
		strcpy(session_id,"NULL-session");
	}

	OpenTAS_get_session_data(session_id, &studienummer,
				 &wachtwoord, &tas_stud_id);

	tas_query_init();
	tas_query_add("USERNAME=",0);
	tas_query_add(studienummer,1);
	tas_query_add("&PASSWORD=",0);
	tas_query_add(wachtwoord,1);
	tas_query_add("&request=SelSel&tas_stud_id=",0);
	tas_query_add(tas_stud_id,1);

	if (do_tas_query(&tasresponse,&tasresponse_len)!=0) {
		OpenTAS_send_pagestart(1,1,1,NULL);
		OpenTAS_navigate(session_id);
		fprintf(cgiOut,
			"Er is een fout opgetreden:<br>\n"
			"Communicatie met TAS-server mislukt (%s)<br>\n"
			"</body>\n</html>\n", untag(tasresponse));
		exit(0);
	}
	inittasresponse(tasresponse);

	OpenTAS_check_foutnr(session_id);

	OpenTAS_send_pagestart(1,1,0,NULL);
	OpenTAS_navigate(session_id);

	fprintf(cgiOut,
		"Maak een selectie:\n<p>\n"
		"<form action=\"aanmeld_res.cgi\" method=\"post\">\n"
		"<input type=\"hidden\" name=\"session_id\" "
		"value=\"%s\">\n",
		untag(session_id));
	fprintf(cgiOut,
		"<table border=\"0\" rules=\"none\" frame=\"void\" "
		"cellspacing=\"5\">\n<tr>\n<td>Activiteit:</td>\n<td>\n"
		"<select size=\"1\" name=\"evn_soort\">\n"
		"<option value=\"\" selected>Alle</option>\n"
		"<option value=\"Tentamen\">Tentamen</option>\n"
		"<option value=\"Practcicum\">Practicum</option>\n"
		"</select>\n</td></tr>\n<tr>\n<td>");
	fprintf(cgiOut,
		"Onderwijsgevende opleiding:</td>\n<td>\n"
		"<select size=\"1\" name=\"tas_ople_id\">\n"
		"<option value=\"\" selected>Alle</option>\n");

	reset_tasvaluepointer();
	dsm_counter=0;
	dsm_list=malloc(sizeof(struct doublestringmaplet));
	dsm_pointer=dsm_list;
	while ((temppointer=findnextvalue("tas_ople_id"))!=NULL) {
		dsm_pointer->string1=strdup(temppointer);
		dsm_pointer2=malloc(sizeof(struct doublestringmaplet));
		dsm_pointer->next=dsm_pointer2;
		dsm_pointer=dsm_pointer->next;
		dsm_counter++;
	}

	reset_tasvaluepointer();
	dsm_pointer=dsm_list;
	while (dsm_counter>0) {
		fprintf(cgiOut,"<option value=\"%s\">",
			untag(dsm_pointer->string1));
		fprintf(cgiOut,"%s</option>\n",
			untag(findnextvalue("opleidingnaam")));
		dsm_pointer2=dsm_pointer;
		dsm_pointer=dsm_pointer->next;
		free(dsm_pointer2->string1);
		dsm_pointer2->string1=NULL;
		free(dsm_pointer2);
		dsm_pointer2=NULL;
		dsm_counter--;
	}

	fprintf(cgiOut,
		"</select>\n</td></tr>\n<tr>\n<td>Soort vak:</td>\n<td>");
	fprintf(cgiOut,
		"<select size=\"1\" name=\"vak_type\">\n"
		"<option value=\"\" selected>Alle</option>\n");

	reset_tasvaluepointer();
	while ((temppointer=findnextvalue("vak_type"))!=NULL) {
		fprintf(cgiOut,"<option value=\"%s\">",
			untag(temppointer));
		fprintf(cgiOut,"%s</option>\n",
			untag(temppointer));
	}

	fprintf(cgiOut,
		"</select>\n</td></tr>\n");
#if 0
	fprintf(cgiOut,
		"<tr>\n<td>Vak:</td>\n<td>");
	fprintf(cgiOut,
		"<select size=\"4\" name=\"tas_vak_id\">\n"
		"<option value=\"\" selected>Alle</option>\n");

	reset_tasvaluepointer();
	dsm_counter=0;
	dsm_list=malloc(sizeof(struct doublestringmaplet));
	dsm_pointer=dsm_list;
	while ((temppointer=findnextvalue("tas_vak_id"))!=NULL) {
		dsm_pointer->string1=strdup(temppointer);
		dsm_pointer2=malloc(sizeof(struct doublestringmaplet));
		dsm_pointer->next=dsm_pointer2;
		dsm_pointer=dsm_pointer->next;
		dsm_counter++;
	}
	reset_tasvaluepointer();
	dsm_pointer=dsm_list;
	while (dsm_counter>0) {
		fprintf(cgiOut,"<option value=\"%s\">",
			untag(dsm_pointer->string1));
		fprintf(cgiOut,"%s</option>\n",
			untag(findnextvalue("vak_oms_ned")));
		dsm_pointer2=dsm_pointer;
		dsm_pointer=dsm_pointer->next;
		free(dsm_pointer2->string1);
		dsm_pointer2->string1=NULL;
		free(dsm_pointer2);
		dsm_pointer2=NULL;
		dsm_counter--;
	}

	fprintf(cgiOut,
		"</select>\n</td></tr>\n");
#endif
	fprintf(cgiOut,
		"<tr>\n<td colspan=\"2\" align=\"center\">"
		"<input type=\"submit\" value=\"Resultaat\"></td></tr>\n"
		"</form>\n"
		"</table>\n</body>\n</html>\n");

	return 0;
}
