/* logout.c, logout, destroys the current session.

 * Copyright (C) 2001,2002 M.C. Bezemer
 *
 * Licensed under the terms of the GNU General Public License.
 * ABSOLUTELY NO WARRANTY.
 * See the file `COPYING' in this directory.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include <cgic.h>

#include "untag.h"
#include "urlencode.h"
#include "urldecode.h"
#include "findvalue.h"
#include "tasquery.h"
#include "session.h"
#include "basicfunc.h"


int cgiMain(void)
{
	char session_id[35];
	cgiFormResultType status;

	status=cgiFormString("session_id",session_id,35);
	if (status!=cgiFormSuccess) {
		OpenTAS_send_pagestart(1,1,1,NULL);
		fprintf(cgiOut,
			"Er is een fout opgetreden:<br>\n"
			"Ongeldig session_id!\n"
			"</html>\n</body>\n");
		exit(0);
	}

	if (destroy_session(session_id)!=0) {
		if (destroy_session(session_id)!=0) {
			OpenTAS_send_pagestart(1,1,1,NULL);
			fprintf(cgiOut,
				"Er is een fout opgetreden:<br>\n"
				"Fout bij verwijderen sessiedata.\n"
				"</body>\n</html>\n");
			exit(0);
		}
	}

	OpenTAS_send_pagestart(1,1,0,
			       "<meta http-equiv=\"refresh\" content="
			       "\"5; url=https://www.opentas.org/\">");
	fprintf(cgiOut,
		"Je bent uitgelogd.<br>\n<p>\n"
		"Je keert over enkele seconden terug naar de "
		"<a href=\"https://www.opentas.org/\">hoofdpagina</a>.\n"
		"</body>\n</html>\n");

	return 0;
}
