/* overzicht_det.c, read (and show) detailed information for selected event
 * from TAS database

 * Copyright (C) 2001,2002 M.C. Bezemer
 *
 * Licensed under the terms of the GNU General Public License.
 * ABSOLUTELY NO WARRANTY.
 * See the file `COPYING' in this directory.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include <cgic.h>

#include "untag.h"
#include "urlencode.h"
#include "urldecode.h"
#include "findvalue.h"
#include "tasquery.h"
#include "session.h"
#include "basicfunc.h"


int cgiMain(void)
{
	char session_id[35];
	char *studienummer=NULL;
	char *wachtwoord=NULL;
	char *tas_stud_id=NULL;
	char evn_soort[100];
	char tas_even_id[100];
	cgiFormResultType status;
	char *tasresponse=NULL;
	size_t tasresponse_len=0;
	int status_error=0;

	status=cgiFormString("session_id",session_id,35);
	if (status!=cgiFormSuccess) {
		strcpy(session_id,"NULL-session");
	}

	OpenTAS_get_session_data(session_id, &studienummer,
				 &wachtwoord, &tas_stud_id);

	status=cgiFormString("tas_even_id",tas_even_id,100);
	if (status!=cgiFormSuccess) {
		status_error+=1;
	}
	status=cgiFormString("evn_soort",evn_soort,100);
	if (status!=cgiFormSuccess) {
		status_error+=2;
	}

	if (status_error) {
		OpenTAS_send_pagestart(1,1,1,NULL);
		OpenTAS_navigate(session_id);
		fprintf(cgiOut,
			"Er is een fout opgetreden:<br>\n"
			"Ongeldig tas_even_id of ongeldige evn_soort.<br>\n"
			"</body>\n</html>\n");
		exit(0);
	}

	tas_query_init();
	tas_query_add("USERNAME=",0);
	tas_query_add(studienummer,1);
	tas_query_add("&PASSWORD=",0);
	tas_query_add(wachtwoord,1);
	tas_query_add("&request=EvnDet&evn_soort=",0);
	tas_query_add(evn_soort,1);
	tas_query_add("&tas_even_id=",0);
	tas_query_add(tas_even_id,1);
	tas_query_add("&tas_stud_id=",0);
	tas_query_add(tas_stud_id,1);

	if (do_tas_query(&tasresponse,&tasresponse_len)!=0) {
		OpenTAS_send_pagestart(1,1,1,NULL);
		OpenTAS_navigate(session_id);
		fprintf(cgiOut,
			"Er is een fout opgetreden:<br>\n"
			"Communicatie met TAS-server mislukt (%s)<br>\n"
			"</body>\n</html>\n", untag(tasresponse));
		exit(0);
	}
	inittasresponse(tasresponse);

	OpenTAS_check_foutnr(session_id);

	OpenTAS_send_pagestart(1,1,0,NULL);
	OpenTAS_navigate(session_id);

if (strcmp(tas_stud_id,"35588")==0) {
fprintf(cgiOut,"tasresponse: %s<br>\n",tasresponse);
}

	fprintf(cgiOut,
		"<table><tr><td>\n"
		"<form action=\"overzicht.cgi\" method=\"post\">\n"
		"<input type=\"hidden\" name=\"session_id\" "
		"value=\"%s\">\n",
		untag(session_id));
	fprintf(cgiOut,
		"<br>"
		"<input type=\"submit\" value=\"Terug naar het overzicht\">\n"
		"</form>\n"
		"</td></tr></table>\n<br>\n");


//	fprintf(cgiOut,
//		"FIXME!\n<p>\n");

	fprintf(cgiOut,
		"<table border=\"0\" rules=\"none\" frame=\"void\" "
		"cellspacing=\"3\">\n");

	fprintf(cgiOut,
		"<tr><td>Activiteit</td><td>%s</td></tr>\n",
		untag(findfirstvalue("evn_soort")));
	fprintf(cgiOut,
		"<tr><td>Vak</td><td>%s",
		untag(findfirstvalue("vak_oms_ned")));
	fprintf(cgiOut,
		" (%s)</td></tr>\n",
		untag(findfirstvalue("oe_code")));
	fprintf(cgiOut,
		"<tr><td>Datum/tijd</td><td>%s",
		untag(findfirstvalue("evn_datum")));
	fprintf(cgiOut,
		"&nbsp;&nbsp;&nbsp;%s</td></tr>\n",
		untag(findfirstvalue("tijd")));
	fprintf(cgiOut,
		"<tr><td>Omschrijving</td><td>%s</td></tr>\n",
		untag(findfirstvalue("omschrijving")));
	fprintf(cgiOut,
		"<tr><td>Opmerking OSA</td><td>%s</td></tr>\n",
		untag(findfirstvalue("opmerking")));
	fprintf(cgiOut, "<tr><td>&nbsp;</td><td></td></tr>\n");

	fprintf(cgiOut,
		"<tr><td>Vak (eng)</td><td>%s</td></tr>\n",
		untag(findfirstvalue("vak_oms_eng")));
	fprintf(cgiOut,
		"<tr><td>Studiepnt.</td><td>%s</td></tr>\n",
		untag(findfirstvalue("res_stpt")));
	fprintf(cgiOut,
		"<tr><td>Studiepnt. (eur)</td><td>%s</td></tr>\n",
		untag(findfirstvalue("ects_stpt")));
	fprintf(cgiOut,
		"<tr><td>Studiebel. uren</td><td>%s</td></tr>\n",
		untag(findfirstvalue("sbu")));
	fprintf(cgiOut, "<tr><td>&nbsp;</td><td></td></tr>\n");

	fprintf(cgiOut,
		"<tr><td>Aanmelden mogelijk tot</td><td>%s</td></tr>\n",
		untag(findfirstvalue("datum_stop_aanmeld")));
	fprintf(cgiOut,
		"<tr><td>Status bij aanmelden</td><td>%s</td></tr>\n",
		untag(findfirstvalue("std_aanmeld_status")));
	fprintf(cgiOut,
		"<tr><td>Afmelden mogelijk tot</td><td>%s</td></tr>\n",
		untag(findfirstvalue("datum_stop_terugtrek")));
	fprintf(cgiOut,
		"<tr><td>Aantal aanmeldingen</td><td>%s</td></tr>\n",
		untag(findfirstvalue("aanmeldingen")));
	fprintf(cgiOut, "<tr><td>&nbsp;</td><td></td></tr>\n");
	fprintf(cgiOut, "<tr><td>Eigen opmerkingen:</td><td>%s</td></tr>\n",
		untag(findfirstvalue("aanmeld_opmerkingen")));
	fprintf(cgiOut, "<tr><td>Aangemeld op:</td><td>%s</td></tr>\n",
		untag(findfirstvalue("aanmeld_datum2")));
//if status=V ???
	fprintf(cgiOut,
		"<tr><td>Voorlopige zaalindeling:</td>");
// else:  ???   fi;
	fprintf(cgiOut,
		"<td>(Definitieve zaalindeling verwacht op %s)</td></tr>\n",
		untag(findfirstvalue("datum_definitief")));
	fprintf(cgiOut,
		"<tr><td>Gebouw-code/naam</td><td>%s",
		untag(findfirstvalue("gebouwcode0")));
	fprintf(cgiOut,
		" / %s</td></tr>\n",
		untag(findfirstvalue("gebouwnaam0")));
	fprintf(cgiOut,
		"<tr><td>Gebouwadres</td><td>%s</td></tr>\n",
		untag(findfirstvalue("gebouwadres0")));
	fprintf(cgiOut,
		"<tr><td>Zaal-code/naam</td><td>%s",
		untag(findfirstvalue("zaalcode0")));
	fprintf(cgiOut,
		" / %s</td></tr>\n",
		untag(findfirstvalue("zaalnaam0")));

	fprintf(cgiOut, "</table>\n");
	fprintf(cgiOut,
		"<table><tr><td>"
		"<form action=\"overzicht_afmtry.cgi\" method=\"post\">\n"
		"<input type=\"hidden\" name=\"session_id\" "
		"value=\"%s\">\n",
		untag(session_id));
	fprintf(cgiOut,
		"<input type=\"hidden\" name=\"evn_soort\" "
		"value=\"%s\">\n",
		untag(evn_soort));
	fprintf(cgiOut,
		"<input type=\"hidden\" name=\"tas_even_id\" "
		"value=\"%s\">\n",
		untag(tas_even_id));
/* eigen opmerking tonen? of wordt die niet teruggegeven?
	if (strcmp(findfirstvalue("opmerking_toegestaan"),"J")==0) {
		fprintf(cgiOut,
			"Eigen opmerking: (max 100 tekens)\n<br>\n"
			"<textarea name=\"aanmeld_opm\" cols=\"50\" "
			"rows=\"4\" wrap=\"off\"></textarea>\n");
	}
*/
	fprintf(cgiOut,
		"<br>"
		"<input type=\"submit\" value=\"Afmelden\">\n"
		"</form></td></tr></table>\n");


	fprintf(cgiOut,
		"<table><tr><td>\n"
		"<form action=\"overzicht.cgi\" method=\"post\">\n"
		"<input type=\"hidden\" name=\"session_id\" "
		"value=\"%s\">\n",
		untag(session_id));
	fprintf(cgiOut,
		"<br>"
		"<input type=\"submit\" value=\"Terug naar het overzicht\">\n"
		"</form>\n"
		"</td></tr></table>\n<br>\n");

	fprintf(cgiOut,
		"</body>\n</html>\n");

	return 0;
}
