/* update_email.c, read current email address from TAS database and offer a
 * field to input a new one.
   
 * Copyright (C) 2001,2002 M.C. Bezemer
 *
 * Licensed under the terms of the GNU General Public License.
 * ABSOLUTELY NO WARRANTY.
 * See the file `COPYING' in this directory.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include <cgic.h>

#include "untag.h"
#include "urlencode.h"
#include "urldecode.h"
#include "findvalue.h"
#include "tasquery.h"
#include "session.h"
#include "basicfunc.h"


int cgiMain(void)
{
	char session_id[35];
	char *studienummer=NULL;
	char *wachtwoord=NULL;
	char *tas_stud_id=NULL;
	cgiFormResultType status;
	char *tasresponse=NULL;
	size_t tasresponse_len=0;

	status=cgiFormString("session_id",session_id,35);
	if (status!=cgiFormSuccess) {
		strcpy(session_id,"NULL-session");
	}

	OpenTAS_get_session_data(session_id, &studienummer,
				 &wachtwoord, &tas_stud_id);

	tas_query_init();
	tas_query_add("USERNAME=",0);
	tas_query_add(studienummer,1);
	tas_query_add("&PASSWORD=",0);
	tas_query_add(wachtwoord,1);
	tas_query_add("&request=SelStd&tas_stud_id=",0);
	tas_query_add(tas_stud_id,1);

	if (do_tas_query(&tasresponse,&tasresponse_len)!=0) {
		OpenTAS_send_pagestart(1,1,1,NULL);
		OpenTAS_navigate(session_id);
		fprintf(cgiOut,
		"Er is een fout opgetreden:<br>\n"
		"Communicatie met TAS-server mislukt (%s)<br>\n"
		"</body>\n</html>\n", untag(tasresponse));
		exit(0);
	}
	inittasresponse(tasresponse);

	OpenTAS_check_foutnr(session_id);

	OpenTAS_send_pagestart(1,1,0,NULL);
	OpenTAS_navigate(session_id);

	fprintf(cgiOut,
		"Huidig email-adres: %s\n<p>\n",
		untag(findfirstvalue("email")));

	fprintf(cgiOut,
		"<table>\n<tr>\n<td>\n"
		"<form action=\"update_email_change.cgi\" method=\"post\">\n"
		"<input type=\"hidden\" name=\"session_id\" "
		"value=\"%s\">\n",
		untag(session_id));
	fprintf(cgiOut,
		"<input type=\"text\" name=\"email\" size=\"50\" "
		"maxlength=\"100\" value=\"%s\">\n",
		untag(findfirstvalue("email")));
	fprintf(cgiOut,
		"<input type=\"submit\" value=\"Pas aan\">\n"
		"</form>\n</td>\n</tr>\n</table>\n");

	fprintf(cgiOut, "</body>\n</html>\n");

	return 0;
}
