/* update_password.c, offer two fields to enter new password.
   
 * Copyright (C) 2001,2002 M.C. Bezemer
 *
 * Licensed under the terms of the GNU General Public License.
 * ABSOLUTELY NO WARRANTY.
 * See the file `COPYING' in this directory.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include <cgic.h>

#include "untag.h"
#include "urlencode.h"
#include "urldecode.h"
#include "findvalue.h"
#include "tasquery.h"
#include "session.h"
#include "basicfunc.h"


int cgiMain(void)
{
	char session_id[35];
	char *studienummer=NULL;
	char *wachtwoord=NULL;
	char *tas_stud_id=NULL;
	cgiFormResultType status;

	status=cgiFormString("session_id",session_id,35);
	if (status!=cgiFormSuccess) {
		strcpy(session_id,"NULL-session");
	}

	OpenTAS_get_session_data(session_id, &studienummer,
				 &wachtwoord, &tas_stud_id);

	OpenTAS_send_pagestart(1,1,0,NULL);
	OpenTAS_navigate(session_id);

	fprintf(cgiOut,
		"U kunt hier uw wachtwoord wijzigen.\n<br>\n"
		"Om terug te gaan: klik op 'Persoonsgegevens'.\n<p>\n");

	fprintf(cgiOut,
		"<form action=\"update_password_change.cgi\" method=\"post\">"
		"\n<input type=\"hidden\" name=\"session_id\" value=\"%s\">\n",
		untag(session_id));
	fprintf(cgiOut,
		"<table>\n<tr>\n<td>Nieuw wachtwoord:</td>\n<td>"
		"<input type=\"password\" name=\"newpass1\" size=\"15\" "
		"maxlength=\"100\" value=\"\"></td>\n</tr>\n");
	fprintf(cgiOut,
		"<tr>\n<td>Bevestiging nieuw wachtwoord:</td>\n<td>"
		"<input type=\"password\" name=\"newpass2\" size=\"15\" "
		"maxlength=\"100\" value=\"\"></td>\n</tr>\n");
	fprintf(cgiOut,
		"<tr>\n<td colspan=\"2\" align=\"center\">"
		"<input type=\"submit\" value=\"Pas aan\"></td>\n"
		"</tr>\n</table>\n</form>\n");

	fprintf(cgiOut, "</body>\n</html>\n");

	return 0;
}
