/* update_password_change.c, update TAS database, set password to the new
 * one given in the form generated by update_password.c(gi)
   
 * Copyright (C) 2001,2002 M.C. Bezemer
 *
 * Licensed under the terms of the GNU General Public License.
 * ABSOLUTELY NO WARRANTY.
 * See the file `COPYING' in this directory.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include <cgic.h>

#include "untag.h"
#include "urlencode.h"
#include "urldecode.h"
#include "findvalue.h"
#include "tasquery.h"
#include "session.h"
#include "basicfunc.h"


int cgiMain(void)
{
	char session_id[35];
	char *studienummer=NULL;
	char *wachtwoord=NULL;
	char *tas_stud_id=NULL;
	char newpass1[101];
	char newpass2[101];
	int newpass1_given=0;
	int newpass2_given=0;
	cgiFormResultType status;
	char *tasresponse=NULL;
	size_t tasresponse_len=0;

	status=cgiFormString("session_id",session_id,35);
	if (status!=cgiFormSuccess) {
		strcpy(session_id,"NULL-session");
	}

	OpenTAS_get_session_data(session_id, &studienummer,
				 &wachtwoord, &tas_stud_id);

	status=cgiFormString("newpass1",newpass1,101);
	if (status!=cgiFormSuccess) {
		newpass1_given=0;
	} else {
		newpass1_given=1;
	}
	status=cgiFormString("newpass2",newpass2,101);
	if (status!=cgiFormSuccess) {
		newpass2_given=0;
	} else {
		newpass2_given=1;
	}

	if ((newpass1_given==0) || (newpass2_given==0)) {
		OpenTAS_send_pagestart(1,1,1,NULL);
		OpenTAS_navigate(session_id);
		fprintf(cgiOut,
			"Er is een fout opgetreden:<br>\n"
			"Wachtwoord en/of bevestiging niet ingevuld."
			"<br>\n<table>\n<tr>\n<td>"
			"<form action=\"update_password.cgi\" method=\"post\">"
			"<input type=\"hidden\" name=\"session_id\" "
			"value=\"%s\"><input type=\"submit\" value=\"Terug\">"
			"</form></td>\n</tr>\n</table>\n</body>\n</html>\n",
			untag(session_id));
		exit(0);
	}

	if (strcmp(newpass1,newpass2)!=0) {
		OpenTAS_send_pagestart(1,1,1,NULL);
		OpenTAS_navigate(session_id);
		fprintf(cgiOut,
			"Er is een fout opgetreden:<br>\n"
			"Wachtwoord en bevestiging niet identiek."
			"<br>\n<table>\n<tr>\n<td>"
			"<form action=\"update_password.cgi\" method=\"post\">"
			"<input type=\"hidden\" name=\"session_id\" "
			"value=\"%s\"><input type=\"submit\" value=\"Terug\">"
			"</form></td>\n</tr>\n</table>\n</body>\n</html>\n",
			untag(session_id));
		exit(0);
	}

	tas_query_init();
	tas_query_add("USERNAME=",0);
	tas_query_add(studienummer,1);
	tas_query_add("&PASSWORD=",0);
	tas_query_add(wachtwoord,1);
	tas_query_add("&request=UpdPwd&password=",0);
	tas_query_add(newpass1,1);
	tas_query_add("&tas_stud_id=",0);
	tas_query_add(tas_stud_id,1);

	if (do_tas_query(&tasresponse,&tasresponse_len)!=0) {
		OpenTAS_send_pagestart(1,1,1,NULL);
		OpenTAS_navigate(session_id);
		fprintf(cgiOut,
			"Er is een fout opgetreden:<br>\n"
			"Communicatie met TAS-server mislukt (%s)<br>\n"
			"</body>\n</html>\n", untag(tasresponse));
		exit(0);
	}
	inittasresponse(tasresponse);

	OpenTAS_check_foutnr(session_id);
	OpenTAS_check_status_1(session_id);

	if (change_session_password(session_id,newpass1)!=0) {
		OpenTAS_send_pagestart(1,1,1,NULL);
		fprintf(cgiOut,
			"Kan het sessie-wachtwoord in OpenTAS niet wijzigen!"
			"<br>\nProbeer opnieuw in te loggen (met het nieuwe "
			"wachtwoord) of neem contact op met de OpenTAS-"
			"beheerder.\n</body>\n</html>\n");
		exit(0);
	}

	OpenTAS_send_pagestart(1,1,0,NULL);
	OpenTAS_navigate(session_id);

	fprintf(cgiOut,	"Het wachtwoord is gewijzigd.<br>\n");

	fprintf(cgiOut, "</body>\n</html>\n");

	return 0;
}
